/*
 * =====================================================================================
 *
 * Copyright (c) 2008-2016 Allwinner Technology Co. Ltd.
 * All rights reserved.
 *       
 *       Filename:  ve_interface.c
 *
 *    Description:  
 *
 *        Version:  1.0
 *        Created:  2020-04-15
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  jilinglin, <jilinglin@allwinnertech.com> 
 *        Company:  
 *
 * =====================================================================================
 */

#include "ve_interface.h"
#include "log.h"
#include "aw_ve.h"

struct ve_interface* ve_create(int type, struct ve_config config)
{
    switch(type) {
		case VE_TYPE_AW:
			return ve_aw_create(config);
		case VE_TYPE_GOOGLE:
			logd("now unsupport!");
			return NULL;
		default:
			logd("mem type unknow!");
			return NULL;
	}
}

void ve_destory(int type, struct ve_interface* p)
{
	switch(type) {
		case VE_TYPE_AW:
			ve_aw_destory(p);
			break;
		case VE_TYPE_GOOGLE:
			logd("now unsupport!");
			break;
		default:
			logd("mem type unknow!");
	}
}
